<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui"><title>Docs as code approach applied to LabVIEW projects</title><meta name="author" content="Olivier Jourdan &lt;olivier.jourdan@wovalab.com&gt;"><link rel="stylesheet" href="reveal.js/css/reset.css"><link rel="stylesheet" href="reveal.js/css/reveal.css"><link rel="stylesheet" href="reveal.js/css/theme/sky.css" id="theme"><!--This CSS is generated by the Asciidoctor reveal.js converter to further integrate AsciiDoc's existing semantic with reveal.js--><style type="text/css">.reveal div.right {
  float: right
}

/* listing block */
.reveal .listingblock.stretch > .content {
  height: 100%
}

.reveal .listingblock.stretch > .content > pre {
  height: 100%
}

.reveal .listingblock.stretch > .content > pre > code {
  height: 100%;
  max-height: 100%
}

/* tables */
table {
  border-collapse: collapse;
  border-spacing: 0
}

table {
  margin-bottom: 1.25em;
  border: solid 1px #dedede
}

table thead tr th, table thead tr td, table tfoot tr th, table tfoot tr td {
  padding: .5em .625em .625em;
  font-size: inherit;
  text-align: left
}

table tr th, table tr td {
  padding: .5625em .625em;
  font-size: inherit
}

table thead tr th, table tfoot tr th, table tbody tr td, table tr td, table tfoot tr td {
  display: table-cell;
  line-height: 1.6
}

td.tableblock > .content {
  margin-bottom: 1.25em
}

td.tableblock > .content > :last-child {
  margin-bottom: -1.25em
}

table.tableblock, th.tableblock, td.tableblock {
  border: 0 solid #dedede
}

table.grid-all > thead > tr > .tableblock, table.grid-all > tbody > tr > .tableblock {
  border-width: 0 1px 1px 0
}

table.grid-all > tfoot > tr > .tableblock {
  border-width: 1px 1px 0 0
}

table.grid-cols > * > tr > .tableblock {
  border-width: 0 1px 0 0
}

table.grid-rows > thead > tr > .tableblock, table.grid-rows > tbody > tr > .tableblock {
  border-width: 0 0 1px
}

table.grid-rows > tfoot > tr > .tableblock {
  border-width: 1px 0 0
}

table.grid-all > * > tr > .tableblock:last-child, table.grid-cols > * > tr > .tableblock:last-child {
  border-right-width: 0
}

table.grid-all > tbody > tr:last-child > .tableblock, table.grid-all > thead:last-child > tr > .tableblock, table.grid-rows > tbody > tr:last-child > .tableblock, table.grid-rows > thead:last-child > tr > .tableblock {
  border-bottom-width: 0
}

table.frame-all {
  border-width: 1px
}

table.frame-sides {
  border-width: 0 1px
}

table.frame-topbot, table.frame-ends {
  border-width: 1px 0
}

.reveal table th.halign-left, .reveal table td.halign-left {
  text-align: left
}

.reveal table th.halign-right, .reveal table td.halign-right {
  text-align: right
}

.reveal table th.halign-center, .reveal table td.halign-center {
  text-align: center
}

.reveal table th.valign-top, .reveal table td.valign-top {
  vertical-align: top
}

.reveal table th.valign-bottom, .reveal table td.valign-bottom {
  vertical-align: bottom
}

.reveal table th.valign-middle, .reveal table td.valign-middle {
  vertical-align: middle
}

table thead th, table tfoot th {
  font-weight: bold
}

tbody tr th {
  display: table-cell;
  line-height: 1.6
}

tbody tr th, tbody tr th p, tfoot tr th, tfoot tr th p {
  font-weight: bold
}

thead {
  display: table-header-group
}

.reveal table.grid-none th, .reveal table.grid-none td {
  border-bottom: 0 !important
}

/* kbd macro */
kbd {
  font-family: "Droid Sans Mono", "DejaVu Sans Mono", monospace;
  display: inline-block;
  color: rgba(0, 0, 0, .8);
  font-size: .65em;
  line-height: 1.45;
  background: #f7f7f7;
  border: 1px solid #ccc;
  -webkit-border-radius: 3px;
  border-radius: 3px;
  -webkit-box-shadow: 0 1px 0 rgba(0, 0, 0, .2), 0 0 0 .1em white inset;
  box-shadow: 0 1px 0 rgba(0, 0, 0, .2), 0 0 0 .1em #fff inset;
  margin: 0 .15em;
  padding: .2em .5em;
  vertical-align: middle;
  position: relative;
  top: -.1em;
  white-space: nowrap
}

.keyseq kbd:first-child {
  margin-left: 0
}

.keyseq kbd:last-child {
  margin-right: 0
}

/* callouts */
.conum[data-value] {
  display: inline-block;
  color: #fff !important;
  background: rgba(0, 0, 0, .8);
  -webkit-border-radius: 50%;
  border-radius: 50%;
  text-align: center;
  font-size: .75em;
  width: 1.67em;
  height: 1.67em;
  line-height: 1.67em;
  font-family: "Open Sans", "DejaVu Sans", sans-serif;
  font-style: normal;
  font-weight: bold
}

.conum[data-value] * {
  color: #fff !important
}

.conum[data-value] + b {
  display: none
}

.conum[data-value]:after {
  content: attr(data-value)
}

pre .conum[data-value] {
  position: relative;
  top: -.125em
}

b.conum * {
  color: inherit !important
}

.conum:not([data-value]):empty {
  display: none
}

/* Callout list */
.hdlist > table, .colist > table {
  border: 0;
  background: none
}

.hdlist > table > tbody > tr, .colist > table > tbody > tr {
  background: none
}

td.hdlist1, td.hdlist2 {
  vertical-align: top;
  padding: 0 .625em
}

td.hdlist1 {
  font-weight: bold;
  padding-bottom: 1.25em
}

/* Disabled from Asciidoctor CSS because it caused callout list to go under the
 * source listing when .stretch is applied (see #335)
 * .literalblock+.colist,.listingblock+.colist{margin-top:-.5em} */
.colist td:not([class]):first-child {
  padding: .4em .75em 0;
  line-height: 1;
  vertical-align: top
}

.colist td:not([class]):first-child img {
  max-width: none
}

.colist td:not([class]):last-child {
  padding: .25em 0
}

/* Override Asciidoctor CSS that causes issues with reveal.js features */
.reveal .hljs table {
  border: 0
}

/* Callout list rows would have a bottom border with some reveal.js themes (see #335) */
.reveal .colist > table th, .reveal .colist > table td {
  border-bottom: 0
}

/* Fixes line height with Highlight.js source listing when linenums enabled (see #331) */
.reveal .hljs table thead tr th, .reveal .hljs table tfoot tr th, .reveal .hljs table tbody tr td, .reveal .hljs table tr td, .reveal .hljs table tfoot tr td {
  line-height: inherit
}

/* Columns layout */
.columns .slide-content {
  display: flex;
}

.columns.wrap .slide-content {
  flex-wrap: wrap;
}

.columns.is-vcentered .slide-content {
  align-items: center;
}

.columns .slide-content > .column {
  display: block;
  flex-basis: 0;
  flex-grow: 1;
  flex-shrink: 1;
}

.columns .slide-content > .column > * {
  padding: .75rem;
}

/* See #353 */
.columns.wrap .slide-content > .column {
  flex-basis: auto;
}

.columns .slide-content > .column.is-full {
  flex: none;
  width: 100%;
}

.columns .slide-content > .column.is-four-fifths {
  flex: none;
  width: 80%;
}

.columns .slide-content > .column.is-three-quarters {
  flex: none;
  width: 75%;
}

.columns .slide-content > .column.is-two-thirds {
  flex: none;
  width: 66.6666%;
}

.columns .slide-content > .column.is-three-fifths {
  flex: none;
  width: 60%;
}

.columns .slide-content > .column.is-half {
  flex: none;
  width: 50%;
}

.columns .slide-content > .column.is-two-fifths {
  flex: none;
  width: 40%;
}

.columns .slide-content > .column.is-one-third {
  flex: none;
  width: 33.3333%;
}

.columns .slide-content > .column.is-one-quarter {
  flex: none;
  width: 25%;
}

.columns .slide-content > .column.is-one-fifth {
  flex: none;
  width: 20%;
}

.columns .slide-content > .column.has-text-left {
  text-align: left;
}

.columns .slide-content > .column.has-text-justified {
  text-align: justify;
}

.columns .slide-content > .column.has-text-right {
  text-align: right;
}

.columns .slide-content > .column.has-text-left {
  text-align: left;
}

.columns .slide-content > .column.has-text-justified {
  text-align: justify;
}

.columns .slide-content > .column.has-text-right {
  text-align: right;
}

.text-left {
  text-align: left !important
}

.text-right {
  text-align: right !important
}

.text-center {
  text-align: center !important
}

.text-justify {
  text-align: justify !important
}

.footnotes {
  border-top: 1px solid rgba(0, 0, 0, 0.2);
  padding: 0.5em 0 0 0;
  font-size: 0.65em;
  margin-top: 4em;
}
</style><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/all.min.css"><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/v4-shims.min.css"><!--Printing and PDF exports--><script>var link = document.createElement( 'link' );
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = window.location.search.match( /print-pdf/gi ) ? "reveal.js/css/print/pdf.css" : "reveal.js/css/print/paper.css";
document.getElementsByTagName( 'head' )[0].appendChild( link );</script><link rel="stylesheet" href="css/wovalab.css"><a href="https://www.wovalab.com">
    <img style="position: absolute; top: 95%; left: 90%; border: 0;" width="160" height="36" src="https://www.wovalab.com/wp-content/uploads/2018/12/Wovalab_logo_header.png" class="custom-logo" alt="wovalab" itemprop="logo" srcset="https://www.wovalab.com/wp-content/uploads/2018/12/Wovalab_logo_H_RVB_1200.png 2x">
</a>

<p style="position: absolute; top: 96%; left: 3%; border: 0;" xmlns:cc="http://creativecommons.org/ns#" ><a href="http://creativecommons.org/licenses/by-sa/4.0/?ref=chooser-v1" target="_blank" rel="license noopener noreferrer" style="display:inline-block;"><img style="height:22px!important;margin-left:3px;vertical-align:text-bottom;" src="https://mirrors.creativecommons.org/presskit/icons/cc.svg?ref=chooser-v1"><img style="height:22px!important;margin-left:3px;vertical-align:text-bottom;" src="https://mirrors.creativecommons.org/presskit/icons/by.svg?ref=chooser-v1"><img style="height:22px!important;margin-left:3px;vertical-align:text-bottom;" src="https://mirrors.creativecommons.org/presskit/icons/sa.svg?ref=chooser-v1"></a></p></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title"><h1>Docs as code approach applied to LabVIEW projects</h1><p class="author"><small>Olivier Jourdan &lt;olivier.jourdan@wovalab.com&gt;</small></p></section><section id="_our_giants_are_not_only_male" class="columns is-vcentered"><h2>#Our Giants Are Not Only Male</h2><div class="slide-content"><div class="paragraph column"><p><strong>Tatiana Boyé</strong> <span class="image" style="float: left"><img src="images/tatiana-boye.jpeg" alt="tatiana boye" width="80%"></span></p></div>
<div class="ulist column"><ul><li><p>Used to do a lot of LabVIEW development</p></li><li><p>Did lots of inspiring presentations during the European CLA summits</p></li><li><p>One of them was related to today&#8217;s topic and inspired much of the work I&#8217;ve been doing these last four years for my open-source projects</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>She had a huge impact on my work.</p></div>
<div class="paragraph"><p>I hope that during these last 24h, you&#8217;ve had the opportunity to experience the same inspiring moment</p></div></aside></div></section>
<section id="_who_am_i" data-background-image="images/intro.png" data-background-size="cover" data-background-opacity="1"><h2>Who Am I?</h2><div class="slide-content"><div class="ulist"><ul><li><p>Olivier Jourdan</p></li><li><p>20+ years programing in LabVIEW</p></li><li><p>Founder of Wovalab in 2018</p></li><li><p>Board member of the DQMH Consortium</p></li></ul></div>
<div class="paragraph"><p><span class="icon"><i class="fa fa-linkedin-square fa-2x"></i></span> <a href="https://www.linkedin.com/in/jourdanolivier/" class="bare">https://www.linkedin.com/in/jourdanolivier/</a></p></div>
<div class="paragraph"><p><span class="icon"><i class="fa fa-twitter-square fa-2x"></i></span> <a href="https://twitter.com/OJourdan" class="bare">https://twitter.com/OJourdan</a></p></div>
<aside class="notes"></aside></div></section>
<section><section id="_introduction" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>Introduction</h2><div class="slide-content"><div class="ulist"><ul><li><p>Why do we write docs</p></li><li><p>How we usually do</p></li><li><p>Why do we almost always fail</p></li></ul></div><aside class="notes"></aside></div></section><section id="_what_and_why_1"><h2>What and why? (1)</h2><div class="slide-content"><div class="paragraph"><p><strong>Source code documentation</strong></p></div>
<div class="ulist"><ul><li><p>To help understand the code</p><div class="ulist"><ul><li><p>For maintenance purposes</p></li><li><p>To onboard new developers on a project</p></li><li><p>To share information with non-developer people</p></li></ul></div></li><li><p>To comply with regulation rules</p></li></ul></div>
<div class="paragraph"><p><strong>Goals</strong></p></div>
<div class="ulist"><ul><li><p>Quality improvement</p></li><li><p>Development management</p></li></ul></div>
<aside class="notes"></aside></div></section><section id="_what_and_why_2"><h2>What and why? (2)</h2><div class="slide-content"><div class="paragraph"><p><strong>Application/API documentation</strong></p></div>
<div class="ulist"><ul><li><p>To help end users</p></li><li><p>To enroll new user</p></li></ul></div>
<div class="paragraph"><p><strong>Goals</strong></p></div>
<div class="ulist"><ul><li><p>Support</p></li><li><p>Marketing</p></li></ul></div>
<aside class="notes"></aside></div></section><section id="_who_is_writing_the_documentation"><h2>Who is writing the documentation?</h2><div class="slide-content"><div class="paragraph"><p>In the theory:</p></div>
<div class="ulist"><ul><li><p>The developer team</p></li><li><p>The support team</p></li><li><p>The marketing team</p></li></ul></div>
<aside class="notes"></aside></div></section><section id="_who_is_actually_writing_it"><h2>Who is actually writing it?</h2><div class="slide-content"><div class="ulist"><ul><li><p>The unlucky guy or nobody</p></li></ul></div>
<aside class="notes"></aside></div></section><section id="_whats_happening_usually"><h2>What&#8217;s happening usually?</h2><div class="slide-content"><div class="ulist"><ul><li><p>Documentation is not a priority task</p></li><li><p>Documentation is not an easy task</p></li><li><p>Documentation processes are rarely well defined</p></li></ul></div>
<div class="paragraph"><p>As a result, if it exists, documentation is often not up to date with code/application/API</p></div>
<div class="admonitionblock caution"><table><tr><td class="icon"><i class="fa fa-fire" title="Caution"></i></td><td class="content">Out of date documentation is often worse than no documentation</td></tr></table></div></div></section><section id="_usual_processes"><h2>Usual "processes"</h2><div class="slide-content"><div class="ulist"><ul><li><p>Tools used: Editor applications (MS Word, HelpNDoc…) / Wiki softwares (Confluence, Dokuwiki…)</p></li><li><p>The documentation and the code are disconnected</p></li><li><p>The documentation task is done after the rest</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Disconnection:</p></div>
<div class="ulist"><ul><li><p>not stored in the same location</p></li><li><p>not part of the definition of done</p></li></ul></div></aside></div></section><section id="_result"><h2>Result</h2><div class="slide-content"><div class="imageblock"><img src="images/vicious-circle.png" alt="vicious circle"></div>
<aside class="notes"><div class="paragraph"><p>This is a vicious circle:</p></div>
<div class="paragraph"><p>Writing doc is too often considered to be a non-valuable task</p></div></aside></div></section></section>
<section><section id="_docs_as_code" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>Docs as Code</h2><div class="slide-content"><div class="ulist"><ul><li><p>What is it</p></li><li><p>What are the goals</p></li><li><p>What we need</p></li></ul></div><aside class="notes"></aside></div></section><section id="_what_is_docs_as_code"><h2>What is Docs as Code</h2><div class="slide-content"><div class="paragraph"><p>Follow the same workflow and use the same tools for your documentation and your development.</p></div>
<div class="olist arabic"><ol class="arabic"><li><p>Place your documentation in your repository.</p></li><li><p>Use issue tracking.</p></li><li><p>Use automated tasks to test, build, and deliver your doc.</p></li></ol></div>
<aside class="notes"></aside></div></section><section id="_the_goals"><h2>The goals</h2><div class="slide-content"><div class="ulist"><ul><li><p>Remove the pain points.</p></li><li><p>Focus on writing content.</p></li><li><p>Deliver documentation with the code.</p></li></ul></div>
<aside class="notes"><div class="ulist"><ul><li><p>Automate the rendering and the delivery</p></li><li><p>Make documentation update part of the definition of done</p></li></ul></div></aside></div></section><section id="_what_we_need"><h2>What we need</h2><div class="slide-content"><div class="ulist"><ul><li><p>A git repository for the code and the documentation</p></li><li><p>A markup language (plain text files instead of binary files)</p></li><li><p>A processor to render the documentation (plain text file to PDF/HTML)</p></li><li><p>An automation tool</p></li></ul></div></div></section></section>
<section><section id="_example_1" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>Example #1</h2><div class="slide-content"><div class="ulist"><ul><li><p>The DQMH Consortium Style Guide</p></li></ul></div><aside class="notes"></aside></div></section><section id="_the_delivery"><h2>The delivery</h2><div class="slide-content"><div class="paragraph"><div class="title">Quote</div><p>This document identifies robust style and programming best practices that should be used when developing software in LabVIEW programming environments.</p></div>
<div class="paragraph"><p>Available in two different formats:</p></div>
<div class="ulist"><ul><li><p><a href="https://dqmh.org/content/styleguide/StyleGuide.pdf" target="_blank">PDF</a></p></li><li><p><a href="https://dqmh.org/content/styleguide/" target="_blank">HTML</a></p></li></ul></div>
<div class="admonitionblock note"><table><tr><td class="icon"><i class="fa fa-info-circle" title="Note"></i></td><td class="content">This example doesn&#8217;t involve LabVIEW code, but the process can be used for writing code documentation.</td></tr></table></div>
<aside class="notes"></aside></div></section><section id="_technics_and_tools"><h2>Technics and tools</h2><div class="slide-content"><div class="ulist"><ul><li><p>Content is written manually using AsciiDoc syntax</p></li><li><p>Asciidoctor process the file to generate the PDF and HTML files</p></li><li><p>A GitLab project is used to get:</p><div class="ulist"><ul><li><p>A repository</p></li><li><p>An issue tracker</p></li><li><p>A CI/CD tool</p></li></ul></div></li></ul></div>
<div class="admonitionblock note"><table><tr><td class="icon"><i class="fa fa-info-circle" title="Note"></i></td><td class="content"><table class="tableblock frame-none grid-all" style="width:100%"><colgroup><col style="width:83.3333%"><col style="width:16.6667%"></colgroup><tbody><tr><td class="tableblock halign-left valign-top"><p class="tableblock">If you want to know more about AsciiDoc and Asciidoctor, watch my <a href="https://youtu.be/r0HKScV6Fwg">GDevCon presentation</a> about creating documentation with LabVIEW</p></td><td class="tableblock halign-left valign-top"><p class="tableblock"><span class="image"><img src="images/qrcode_gdevcon-video.png" alt="qrcode gdevcon video" width="128px"></span></p></td></tr></table></td></tr></table></div>
<aside class="notes"></aside></div></section><section id="_the_process"><h2>The process</h2><div class="slide-content"><div class="ulist"><ul><li><p>Documentation follows Semantic Versioning 👉 We use the GitFlow workflow</p></li><li><p>CI/CD configuration:</p><div class="ulist"><ul><li><p>On the <code>develop</code> and <code>feature</code> branches</p><div class="ulist"><ul><li><p>Render PDF and HTML documents with a <code>draft</code> watermark 👉 Building a beta version</p></li><li><p>Upload files to a draft folder on the dqmh.org website 👉 Deploy in a sandbox</p></li></ul></div></li><li><p>On the <code>release</code> and <code>hotfix</code> branches</p><div class="ulist"><ul><li><p>Render PDF and HTML document 👉 Building the final version</p></li><li><p>Upload files on the dqmh.org website  👉 Deploy in production</p></li></ul></div></li></ul></div></li></ul></div></div></section><section id="_the_process_2"><div class="slide-content"><div class="imageblock"><img src="images/ex1-workflow.png" alt="ex1 workflow"></div>
<aside class="notes"></aside></div></section><section id="_lets_dive_into_the_gitlab_project"><h2>Let&#8217;s dive into the GitLab project</h2><div class="slide-content"><div class="paragraph"><p><a href="https://gitlab.com/dqmhconsortium/open-source/development-guidelines" target="_blank">DQMH Consortium Style Guide GitLab Project</a></p></div>
<aside class="notes"><div class="olist arabic"><ol class="arabic"><li><p>open Style Guide.adoc</p></li><li><p>Note the preview</p></li><li><p>switch to the raw view</p></li><li><p>Show issues</p></li><li><p>Show Pipelines</p><div class="olist loweralpha"><ol class="loweralpha" type="a"><li><p>PDF artifact</p></li><li><p>watermark</p></li><li><p>traceability</p></li><li><p>License inclusion</p></li></ol></div></li></ol></div></aside></div></section><section id="_how_to_write_using_the_asciidoc_syntax"><h2>How to write using the AsciiDoc syntax</h2><div class="slide-content"><div class="paragraph"><p>My setup and recommendation:</p></div>
<div class="ulist"><ul><li><p>Use Visual Studio code + AsciiDoc extension + Code Spell Checker / Grammarly</p></li><li><p>Read the <a href="https://docs.asciidoctor.org/asciidoc/latest/">AsciiDoc documentation website</a></p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>open VS code</p></div></aside></div></section><section id="_what_we_get_with_the_docs_as_code_approach"><h2>What we get with the Docs as Code approach</h2><div class="slide-content"><div class="ulist"><ul><li><p>Auto rendering of the final documents</p></li><li><p>Auto delivery/deployment</p></li><li><p>Content adaption (draft watermark, traceability…)</p></li></ul></div>
<div class="admonitionblock tip"><table><tr><td class="icon"><i class="fa fa-lightbulb-o" title="Tip"></i></td><td class="content"><div class="ulist"><ul><li><p>We can focus on the content</p></li><li><p>The release of a new version of the document is faster than ever.</p></li></ul></div></td></tr></table></div>
<aside class="notes"><div class="paragraph"><p>We focus on writing the best possible content</p></div></aside></div></section></section>
<section><section id="_example_2" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>Example #2</h2><div class="slide-content"><div class="ulist"><ul><li><p>The Wovalab open-source projects documentation website</p></li></ul></div><aside class="notes"></aside></div></section><section id="_the_delivery_2"><h2>The delivery</h2><div class="slide-content"><div class="paragraph"><div class="title">Quote</div><p>This website gathers all information needed to use open-source projects developed and maintained by <a href="https://www.wovalab.com/">Wovalab</a></p></div>
<div class="ulist"><ul><li><p>A <a href="https://wovalab.gitlab.io/open-source/docs/index.html" target="_blank">static website</a></p></li></ul></div>
<aside class="notes"></aside></div></section><section id="_technics_and_tools_2"><h2>Technics and tools</h2><div class="slide-content"><div class="ulist"><ul><li><p>Content is</p><div class="ulist"><ul><li><p>written manually using AsciiDoc syntax</p></li><li><p>generated automatically using <a href="https://www.vipm.io/package/wovalab_lib_antidoc/">Antidoc</a></p></li></ul></div></li><li><p>The website is generated using <a href="https://antora.org/">Antora</a></p></li><li><p>Each open-source GitLab project contains the documentation content</p></li><li><p>Two specific GitLab projects are used to build the website and its UI</p></li></ul></div>
<aside class="notes"></aside></div></section><section id="_the_process_3"><h2>The process</h2><div class="slide-content"><div class="ulist"><ul><li><p>For each open-source project:</p><div class="ulist"><ul><li><p><code>docs</code> branches are created for each documented version</p></li><li><p>Those branches are the source of the content used by Antora</p></li></ul></div></li><li><p>The website is hosted on GitLab pages</p></li></ul></div>
<aside class="notes"></aside></div></section><section id="_the_process_4"><div class="slide-content"><div class="imageblock"><img src="images/ex2-workflow.png" alt="ex2 workflow"></div></div></section><section id="_lets_dive_into_the_gitlab_projects"><h2>Let&#8217;s dive into the GitLab projects</h2><div class="slide-content"><div class="paragraph"><p><a href="https://gitlab.com/wovalab/open-source" target="_blank">Wovalab open-source GitLab Projects</a></p></div>
<aside class="notes"><div class="olist arabic"><ol class="arabic"><li><p>Show docs branches in lvproj</p></li><li><p>Show docs folder</p></li></ol></div></aside></div></section><section id="_what_we_get_with_the_docs_as_code_approach_2"><h2>What we get with the Docs as Code approach</h2><div class="slide-content"><div class="ulist"><ul><li><p>Auto build of the website</p></li><li><p>A documentation that deals with multiple projects and multiple versions</p></li><li><p>A straightforward way to contribute 👉 <a href="https://wovalab.gitlab.io/open-source/docs/index.html" target="_blank">edit this page</a></p></li></ul></div>
<div class="admonitionblock tip"><table><tr><td class="icon"><i class="fa fa-lightbulb-o" title="Tip"></i></td><td class="content"><div class="ulist"><ul><li><p>The development process is greatly improved.</p></li><li><p>Updating the documentation is flawless.</p></li><li><p>Contribution to documentation has never been so easy.</p></li></ul></div></td></tr></table></div>
<aside class="notes"><div class="paragraph"><p>We focus on writing the best possible content</p></div></aside></div></section></section>
<section><section id="_generate_content_automatically" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>Generate content automatically</h2><div class="slide-content"><div class="ulist"><ul><li><p>Antidoc</p></li><li><p>AsciiDoc for LabVIEW toolkit</p></li></ul></div><aside class="notes"><div class="paragraph"><p>Docs as Code</p></div></aside></div></section><section id="_antidoc"><h2>Antidoc</h2><div class="slide-content"><div class="ulist"><ul><li><p>Available on VIPM</p></li><li><p>Create documentation automatically</p></li><li><p>Add-on available:</p><div class="ulist"><ul><li><p>LabVIEW Project</p></li><li><p>LabVIEW toolkit</p></li></ul></div></li></ul></div>
<div class="admonitionblock note"><table><tr><td class="icon"><i class="fa fa-info-circle" title="Note"></i></td><td class="content">the documentation is generated using the AsciiDoc syntax.</td></tr></table></div>
<aside class="notes"></aside></div></section><section id="_lv_proj_sample" data-background-iframe="https://wovalab.gitlab.io/open-source/docs/antidoc-addon-lvproj/latest/_attachments/basic-interfaces/Project-Documentation.html"></section><section id="_toolkit_sample" data-background-iframe="https://wovalab.gitlab.io/open-source/docs/antidoc-addon-toolkit/latest/_attachments/asciidoc-for-labview/AsciiDoc%20for%20LabVIEW%20-%20v1.6.0.52.html"></section><section id="_toolkit_doc_integration" data-background-iframe="https://wovalab.gitlab.io/open-source/docs/asciidoc-toolkit/latest/api.html"></section><section id="_create_your_own_automated_content"><h2>Create your own automated content</h2><div class="slide-content"><div class="ulist"><ul><li><p>Create an add-on for Antidoc</p></li><li><p>Use the AsciiDoc for LabVIEW toolkit to create AsciiDoc files automatically.</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Antidoc has an add-on mechanism.
You can create your own type of document.</p></div></aside></div></section></section>
<section><section id="_conclusion" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>Conclusion</h2><div class="slide-content"><div class="ulist"><ul><li><p>What we get with the Docs as Code approach</p></li><li><p>How can we improve it</p></li></ul></div><aside class="notes"><div class="paragraph"><p>we just saw two different implementations of the Docs as Code approach.</p></div>
<div class="paragraph"><p>If I convinced you to go that way, you&#8217;ll need to adapt the approach to your context</p></div></aside></div></section><section id="_what_we_get"><h2>What we get</h2><div class="slide-content"><div class="ulist"><ul><li><p>Documentation task is part of the development process 👉 You can&#8217;t forget it anymore</p></li><li><p>Repetitive and boring tasks are automated 👉 You focus on the content and you know the documentation will be available and valuable</p></li><li><p>You have set up a process 👉 You are ready to increase the number of contributors to your documentation</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Doc is par of the definition of done</p></div></aside></div></section><section id="_possible_improvement"><h2>Possible improvement</h2><div class="slide-content"><div class="ulist"><ul><li><p>Test the content:</p><div class="ulist"><ul><li><p>test urls</p></li><li><p>test spelling</p></li><li><p>word blacklist</p></li></ul></div></li><li><p>Improve integration of autogenerated content into documentation</p></li></ul></div></div></section><section id="_a_final_word"><h2>A final word</h2><div class="slide-content"><div class="imageblock"><img src="images/dan-allen-quote.png" alt="dan allen quote" width="100%"></div>
<div class="admonitionblock note"><table><tr><td class="icon"><i class="fa fa-info-circle" title="Note"></i></td><td class="content">Docs as Code is not going to make writing prose easier, but at least it will allow you to focus on this unique task</td></tr></table></div></div></section></section>
<section id="_questions"><h2>Questions?</h2><div class="slide-content"><table class="tableblock frame-none grid-all" style="width:100%"><colgroup><col style="width:83.3333%"><col style="width:16.6667%"></colgroup><tbody><tr><td class="tableblock halign-left valign-top"><p class="tableblock">wovalab open-source projects in GitLab</p></td><td class="tableblock halign-left valign-top"><p class="tableblock"><span class="image"><img src="images/qrcode_wovalab-os.png" alt="qrcode wovalab os" width="128px"></span></p></td></tr><tr><td class="tableblock halign-left valign-top"><p class="tableblock">DQMH Consortium Style Guide</p></td><td class="tableblock halign-left valign-top"><p class="tableblock"><span class="image"><img src="images/qrcode_style-guide.png" alt="qrcode style guide" width="128px"></span></p></td></tr></table>
<aside class="notes"></aside></div></section></div></div><script src="reveal.js/js/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
});

// More info about config & dependencies:
// - https://github.com/hakimel/reveal.js#configuration
// - https://github.com/hakimel/reveal.js#dependencies
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'edges',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: 'c/t',
  // Control which views the slide number displays on
  showSlideNumber: 'speaker',
  // Add the current slide number to the URL hash so that reloading the
  // page/copying the URL will return you to the same slide
  hash: false,
  // Push each slide change to the browser history. Implies `hash: true`
  history: true,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Disables the default reveal.js slide layout so that you can use custom CSS layout
  disableLayout: false,
  // Vertical centering of slides
  center: true,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // See https://github.com/hakimel/reveal.js/#navigation-mode
  navigationMode: 'default',
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: true,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: true,
  // Global override for preloading lazy-loaded iframes
  // - null: Iframes with data-src AND data-preload will be loaded when within
  //   the viewDistance, iframes with only data-src will be loaded when visible
  // - true: All iframes with data-src will be loaded when within the viewDistance
  // - false: All iframes with data-src will be loaded only when visible
  preloadIframes: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Specify the total time in seconds that is available to
  // present.  If this is set to a nonzero value, the pacing
  // timer will work out the time available for each slide,
  // instead of using the defaultTiming value
  totalTime: 2400,
  // Specify the minimum amount of time you want to allot to
  // each slide, if using the totalTime calculation method.  If
  // the automated time allocation causes slide pacing to fall
  // below this threshold, then you will see an alert in the
  // speaker notes window
  minimumTimePerSlide: 0,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hide cursor if inactive
  hideInactiveCursor: true,
  // Time before the cursor is hidden (in ms)
  hideCursorTime: 5000,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 5,
  // Number of slides away from the current that are visible on mobile
  // devices. It is advisable to set this to a lower number than
  // viewDistance in order to save resources.
  mobileViewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 1500,
  height: 1000,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // PDF Export Options
  // Put each fragment on a separate page
  pdfSeparateFragments: true,
  // For slides that do not fit on a page, max number of pages
  pdfMaxPagesPerSlide: 1,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'reveal.js/plugin/zoom-js/zoom.js', async: true },
      { src: 'reveal.js/plugin/notes/notes.js', async: true }
  ],

  

});</script><script>var dom = {};
dom.slides = document.querySelector('.reveal .slides');

function getRemainingHeight(element, slideElement, height) {
  height = height || 0;
  if (element) {
    var newHeight, oldHeight = element.style.height;
    // Change the .stretch element height to 0 in order find the height of all
    // the other elements
    element.style.height = '0px';
    // In Overview mode, the parent (.slide) height is set of 700px.
    // Restore it temporarily to its natural height.
    slideElement.style.height = 'auto';
    newHeight = height - slideElement.offsetHeight;
    // Restore the old height, just in case
    element.style.height = oldHeight + 'px';
    // Clear the parent (.slide) height. .removeProperty works in IE9+
    slideElement.style.removeProperty('height');
    return newHeight;
  }
  return height;
}

function layoutSlideContents(width, height) {
  // Handle sizing of elements with the 'stretch' class
  toArray(dom.slides.querySelectorAll('section .stretch')).forEach(function (element) {
    // Determine how much vertical space we can use
    var limit = 5; // hard limit
    var parent = element.parentNode;
    while (parent.nodeName !== 'SECTION' && limit > 0) {
      parent = parent.parentNode;
      limit--;
    }
    if (limit === 0) {
      // unable to find parent, aborting!
      return;
    }
    var remainingHeight = getRemainingHeight(element, parent, height);
    // Consider the aspect ratio of media elements
    if (/(img|video)/gi.test(element.nodeName)) {
      var nw = element.naturalWidth || element.videoWidth, nh = element.naturalHeight || element.videoHeight;
      var es = Math.min(width / nw, remainingHeight / nh);
      element.style.width = (nw * es) + 'px';
      element.style.height = (nh * es) + 'px';
    } else {
      element.style.width = width + 'px';
      element.style.height = remainingHeight + 'px';
    }
  });
}

function toArray(o) {
  return Array.prototype.slice.call(o);
}

Reveal.addEventListener('slidechanged', function () {
  layoutSlideContents(1500, 1000)
});
Reveal.addEventListener('ready', function () {
  layoutSlideContents(1500, 1000)
});
Reveal.addEventListener('resize', function () {
  layoutSlideContents(1500, 1000)
});</script></body></html>